#ifndef _Destination_h
#define _Destination_h


/*
 * A Destination is the representation of a client who wants to receive
 * a packet stream. It includes a ACE_SOCK_Dgram to send packets on.
 */

#include <ace/SOCK_Dgram.h>
#include <ace/INET_Addr.h>

#include "nexus.h"

#define MAX_PACKET_TYPES 129

class Destination
{
public:
    Destination(char *host, int port,
		nexus_global_pointer_t *cb_gp, 
		int n_packet_types, int *packet_types);

    int matches(char *host, int port);

    int wants_type(int packet_type);

    void send_rtp_packet(int rtp_type, char *packet, int len);
    void send_rtcp_packet(char *packet, int len);
    void send_rtcp_packet(int rtp_type, char *packet, int len);
    void send_callback(char *handler, char *msg);
    
protected:
    nexus_global_pointer_t *callback_gp_;
    
    char want_packet_[MAX_PACKET_TYPES];
    ACE_INET_Addr rtp_address_;
    ACE_INET_Addr rtcp_address_;
    
    ACE_SOCK_Dgram rtp_sock_;
    ACE_SOCK_Dgram rtcp_sock_;
};

#endif /* _Destination_h */
