#include "Disk_Writer.h"
//#include "Reflector.h"

Disk_Writer::Disk_Writer(char *directory) :
			finished_(0),
			directory_(directory)
//			reflector(NULL)
{
}

Disk_Writer::~Disk_Writer()
{
    printf("DW Destruct\n");
}

#if 0
void Disk_Writer::setup_reflector(char *host, unsigned short *ports,
				  int n_ports)
{
    extern ACE_Reactor *glb_reactor;
    int i;
    
    reflector = new Reflector(port, glb_reactor);

    for (i = 0; i < n_ports; i++)
    {
	reflector->add_address(host);
    }
}
#endif

void Disk_Writer::handle_packet(RTP_Packet::RTP_Header *packet_header,
				char *packet, int packet_size,
				ACE_INET_Addr &packet_source)
{
    SSRC_Writer *swriter;
    
#if 0
    printf("DW: got rtp packet of length %d\n", packet_size);
    printf("flags=%x v=%d pad=%d ext=%d cc=%d marker=%d pt=%d seq=%d ssrc=%x\n",
	   
	   packet_header->get_flags(),
	   packet_header->get_version(),
	   packet_header->get_padding(),
	   packet_header->get_extension(),
	   packet_header->get_csrc_count(),
	   packet_header->get_marker(),
	   packet_header->get_packet_type(),
	   packet_header->get_sequence(),
	   packet_header->get_ssrc());
#endif

#ifdef USE_IBM_CL

    if (!writer_keyset_.containsElementWithKey(packet_header->get_ssrc()))
    {
	swriter = new SSRC_Writer(this, packet_header->get_ssrc());
	writer_keyset_.addOrReplaceElementWithKey(swriter);
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source, 1);
    }
    else
    {
	swriter = writer_keyset_.elementWithKey(packet_header->get_ssrc());
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source);
    }
#else

    swriter = writer_hash.lookup(packet_header->get_ssrc());
    if (swriter == (SSRC_Writer *) NULL)
    {
	swriter = new SSRC_Writer(this, packet_header->get_ssrc());
	writer_hash.add(packet_header->get_ssrc(), swriter);
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source, 1);
    }
    else
    {
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source);
    }
#endif

#if 0
    if (reflector)
    {
	reflector->handle_packet(packet_header, packet, packet_size,
				 packet_source);
    }
#endif
}
    
void Disk_Writer::handle_packet(RTCP_Packet::RTCP_Header *packet_header,
				char *packet, int packet_size,
				ACE_INET_Addr &packet_source)
{
    SSRC_Writer *swriter;

#if 0
    printf("DW: got rtcp packet of length %d\n", packet_size);
    printf("flags=%x version=%d padding=%d rc=%d pt=%d len=%d ssrc=%x\n",
	   packet_header->get_flags(),
	   packet_header->get_version(),
	   packet_header->get_padding(),
	   packet_header->get_reception_count(),
	   packet_header->get_packet_type(),
	   packet_header->get_length(),
	   packet_header->get_ssrc());
#endif

#ifdef USE_IBM_CL

    if (!writer_keyset_.containsElementWithKey(packet_header->get_ssrc()))
    {
	swriter = new SSRC_Writer(this, packet_header->get_ssrc());
	writer_keyset_.addOrReplaceElementWithKey(swriter);
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source, 1);
    }
    else
    {
	swriter = writer_keyset_.elementWithKey(packet_header->get_ssrc());
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source);
    }

#else

    swriter = writer_hash.lookup(packet_header->get_ssrc());
    if (swriter == (SSRC_Writer *) NULL)
    {
	swriter = new SSRC_Writer(this, packet_header->get_ssrc());
	writer_hash.add(packet_header->get_ssrc(), swriter);
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source, 1);
    }
    else
    {
	swriter->handle_packet(packet_header, packet, packet_size,
			       packet_source);
    }
#endif    

#if 0
    if (reflector)
    {
	reflector->handle_packet(packet_header, packet, packet_size,
				 packet_source);
    }
#endif
}

void Disk_Writer::handle_subpacket(RTCP_Packet::RTCP_Header *packet_header,
				   char *packet, int packet_size,
				   ACE_INET_Addr &packet_source)
{
    SSRC_Writer *swriter;

#ifdef USE_IBM_CL

    if (!writer_keyset_.containsElementWithKey(packet_header->get_ssrc()))
    {
	swriter = new SSRC_Writer(this, packet_header->get_ssrc());
	writer_keyset_.addOrReplaceElementWithKey(swriter);
	swriter->handle_subpacket(packet_header, packet, packet_size,
				  packet_source);
    }
    else
    {
	swriter = writer_keyset_.elementWithKey(packet_header->get_ssrc());
	swriter->handle_subpacket(packet_header, packet, packet_size,
				  packet_source);
    }
#else
    swriter = writer_hash.lookup(packet_header->get_ssrc());
    if (swriter == (SSRC_Writer *) NULL)
    {
	swriter = new SSRC_Writer(this, packet_header->get_ssrc());
	writer_hash.add(packet_header->get_ssrc(), swriter);
	swriter->handle_subpacket(packet_header, packet, packet_size,
				  packet_source);
    }
    else
    {
	swriter->handle_subpacket(packet_header, packet, packet_size,
				  packet_source);
    }
#endif

}

int Disk_Writer::handle_timeout(const ACE_Time_Value &tv, const void *arg)
{
    ACE_Time_Value delta;
    
    delta = tv - last_tick_;
    
#ifdef USE_IBM_CL

    SSRC_Writer_Cursor c(writer_keyset_);
    
    forCursor(c)
    {
	writer_keyset_.elementAt(c)->tick(tv, last_tick_, delta);
    }
#else
    writer_hash.call_tick(tv, last_tick_, delta);
#endif
    
    last_tick_ = tv;
    
    return 0;
}


int Disk_Writer::handle_signal (ACE_HANDLE signum HANDLE_SIGNAL_ARGS)
{
    printf("Got signal %d\n", signum);
    finished_ = 1;
    return 0; 			// To make the compiler happy
}

void Disk_Writer::ssrc_finished(SSRC_Writer *writer)
{
    printf("DW: got finished for ssrc %x\n", writer->ssrc());

#ifdef USE_IBM_CL
    writer_keyset_.removeElementWithKey(writer->ssrc());
#else
    writer_hash.remove(writer->ssrc());
#endif
    delete writer;
    
}

void Disk_Writer::terminate()
{
#ifdef USE_IBM_CL
    SSRC_Writer_Cursor c(writer_keyset_);
    
    forCursor(c)
    {
	writer_keyset_.elementAt(c)->terminate();
    }
#else
    writer_hash.call_terminate();
#endif
}
