#include "Media_Stream.h"

/*
 * Instantiate the templates...
 */

//#include "Packet_Handler.C"

Media_Stream::Media_Stream(unsigned short port, 
			   RTP_Packet_Sink *rtp_sink,
			   RTCP_Packet_Sink *rtcp_sink) :
			   port_(port),
			   rtp_addr_(port_),
			   rtcp_addr_(port_ + 1),
			   rtp_socket_(rtp_addr_),
			   rtcp_socket_(rtcp_addr_),
			   rtp_sink_(rtp_sink),
			   rtcp_sink_(rtcp_sink),
			   rtp_handler_(&rtp_socket_, rtp_sink),
			   rtcp_handler_(&rtcp_socket_, rtcp_sink)
{
}

Media_Stream::~Media_Stream(void)
{
}

void Media_Stream::register_with_reactor(ACE_Reactor *reactor)
{
    if (reactor->register_handler(&rtp_handler_, ACE_Event_Handler::READ_MASK) < 0)
    {
	printf("Register tcp handler for port %d failed\n", port_);
    }

    if (reactor->register_handler(&rtcp_handler_, ACE_Event_Handler::READ_MASK) <0)
    {
	printf("Register tcp handler for port %d failed\n", port_);
    }
}
