
#include "Nexus_Handler.h"
#include "ace/Reactor.h"
#include "nexus.h"

ACE_Reactor *Nexus_Handler::reactor_;
Nexus_Handler *Nexus_Handler::fd_to_handler_[MAX_FDS];

Nexus_Handler::Nexus_Handler(int fd) : fd_(fd)
{
}

int Nexus_Handler::handle_input(ACE_HANDLE fd)
{
    nexus_poll();
    return 0;
}

void Nexus_Handler::register_with_nexus(ACE_Reactor *reactor)
{
    reactor_ = reactor;
    nexus_register_fd_notifiers(add_fd, remove_fd);
}

void Nexus_Handler::add_fd(int fd)
{
    Nexus_Handler *h;

    h = new Nexus_Handler(fd);

    fd_to_handler_[fd] = h;
    
    if (reactor_->register_handler(h, ACE_Event_Handler::READ_MASK) < 0)
    {
	printf("register nexus handler %x for fd %d failed\n", h, fd);
	exit(1);
    }
//    printf("add handler for %d\n", fd);
}

void Nexus_Handler::remove_fd(int fd)
{
    Nexus_Handler *h;

    h = fd_to_handler_[fd];

    if (!h)
    {
	printf("Nexus_Handler::remove_fd(): didn't find handler for %d\n", fd);
	exit(1);
    }

    if (reactor_->remove_handler(h, ACE_Event_Handler::READ_MASK) < 0)
    {
	printf("remove nexus handler %x for fd %d failed\n", h, fd);
	exit(1);
    }
    fd_to_handler_[fd] = NULL;
//    printf("remove handler for %d\n", fd);
}
