#ifndef _Nexus_Handler_h
#define _Nexus_Handler_h

#include "ace/Event_Handler.h"

class ACE_Reactor;

#define MAX_FDS 1024

class Nexus_Handler : public ACE_Event_Handler
{
public:
    Nexus_Handler(int fd);

    static void register_with_nexus(ACE_Reactor *reactor);

protected:
    int fd_;

    virtual ACE_HANDLE get_handle(void) const { return fd_; }
    virtual int handle_input(ACE_HANDLE fd);

    static void add_fd(int fd);
    static void remove_fd(int fd);

    static ACE_Reactor *reactor_;
    static Nexus_Handler *fd_to_handler_[MAX_FDS];
};


#endif /* _Nexus_Handler_h */

