#ifndef _RTCP_Packet_Sink_h
#define _RTCP_Packet_Sink_h

/*
 * Mixin class for objects that can sink an RTCP packet stream.
 */

#include "RTCP_Packet.h"
#include "ace/INET_Addr.h"

class RTCP_Packet_Sink
{
public:
    virtual void handle_packet(RTCP_Packet::RTCP_Header *packet_header,
			       char *packet, int packet_size,
			       ACE_INET_Addr &packet_source) = 0;
			       
    virtual void handle_subpacket(RTCP_Packet::RTCP_Header *packet_header,
			       char *packet, int packet_size,
			       ACE_INET_Addr &packet_source) = 0;
			       
};

#endif /* _RTCP_Packet_Sink_h */
