
#include "RTP_Packet_Handler.h"

RTP_Packet_Handler::RTP_Packet_Handler(ACE_SOCK_Dgram *sock,
				       RTP_Packet_Sink *sink) :
				       Packet_Handler(sock),
				       packet_sink_(sink)
{
}

RTP_Packet_Handler::~RTP_Packet_Handler(void)
{
}

int RTP_Packet_Handler::handle_packet(char *buffer, int size,
				      ACE_INET_Addr &from)
{
    RTP_Packet::RTP_Header *hdr = &(packet_buffer_.u.header_);

    if (packet_sink_)
    {
	packet_sink_->handle_packet(hdr, buffer, size, from);
    }

#if 0
    printf("Got rtp packet of length %d\n", size);
    printf("flags=%x v=%d pad=%d ext=%d cc=%d marker=%d pt=%d seq=%d ssrc=%x\n",
	   
	   hdr->get_flags(),
	   hdr->get_version(),
	   hdr->get_padding(),
	   hdr->get_extension(),
	   hdr->get_csrc_count(),
	   hdr->get_marker(),
	   hdr->get_packet_type(),
	   hdr->get_sequence(),
	   hdr->get_ssrc());

    switch (hdr->get_packet_type())
    {
    case RTP_Packet::PT_JPEG:

	RTP_Packet::JPEG_Header *jpeg_hdr =
	    (RTP_Packet::JPEG_Header *) (buffer + sizeof(*hdr));

	handle_jpeg(hdr, jpeg_hdr,
		    size - sizeof(*hdr) - sizeof(*jpeg_hdr),
		    buffer + sizeof(*hdr) + sizeof(*jpeg_hdr));
    }
#endif
    return 0;
}

#if 0

void RTP_Packet_Handler::handle_jpeg(RTP_Packet::RTP_Header *hdr,
				     RTP_Packet::JPEG_Header *jpeg_hdr,
				     int frame_size,
				     char *frame)
{
    printf("Got jpeg packet mbz=%d frag_off=%d type=%d q=%d w=%d h=%d\n",
	   jpeg_hdr->mbz(),
	   jpeg_hdr->fragment_offset(),
	   jpeg_hdr->type(),
	   jpeg_hdr->q(),
	   jpeg_hdr->width(),
	   jpeg_hdr->height());
}
#endif

char *RTP_Packet_Handler::get_buffer(int *size)
{
    return packet_buffer_.get_buffer(size);
}
