#ifndef _ssrc_hash_h
#define _ssrc_hash_h

#include "ace/Time_Value.h"

class SSRC_Writer;

class SSRC_Hash_Bucket
{
public:
    SSRC_Hash_Bucket(long ssrc, SSRC_Writer *dw, SSRC_Hash_Bucket *next = 0);
    SSRC_Hash_Bucket();

    long ssrc_;
    SSRC_Writer *dw_;

    SSRC_Hash_Bucket *next_;
};

class SSRC_Hash
{
public:
    SSRC_Hash(int size = 1031);
    ~SSRC_Hash();

    void add(long ssrc, SSRC_Writer *);
    void remove(long ssrc);
    SSRC_Writer *lookup(long ssrc);

    void call_tick(ACE_Time_Value, ACE_Time_Value, ACE_Time_Value);
    void call_terminate();
    
protected:
    int size_;
    SSRC_Hash_Bucket *elements_;

    SSRC_Hash_Bucket *get_bucket(long ssrc);

};

#endif
