#ifndef _Tee_h
#define _Tee_h

#include "RTP_Packet_Sink.h"
#include "RTCP_Packet_Sink.h"
#include "ace/Event_Handler.h"


class Tee : public RTP_Packet_Sink, public RTCP_Packet_Sink,
		    public ACE_Event_Handler
{
public:
    Tee(
    ~Tee();

    int finished() { return finished_; } ;
    void terminate();

    const char *directory() { return directory_; } ;

    void ssrc_finished(SSRC_Writer *writer);

//    void setup_reflector(char *host, unsigned short *ports, int n_ports);
    
protected:
    virtual void handle_packet(RTP_Packet::RTP_Header *packet_header,
			       char *packet, int packet_size,
			       ACE_INET_Addr &packet_source);
    
    virtual void handle_packet(RTCP_Packet::RTCP_Header *packet_header,
			       char *packet, int packet_size,
			       ACE_INET_Addr &packet_source);

    virtual void handle_subpacket(RTCP_Packet::RTCP_Header *packet_header,
				  char *packet, int packet_size,
				  ACE_INET_Addr &packet_source);

    virtual int handle_timeout(const ACE_Time_Value &tv, const void *arg);
    virtual int handle_signal (ACE_HANDLE signum HANDLE_SIGNAL_ARGS);

    char *directory_;
    SSRC_Writer_KeySet writer_keyset_;

    int finished_;
    ACE_Time_Value last_tick_;

//    Reflector *reflector;
};

#endif /* _Tee_h */
